<script>

  import { beforeUpdate, onMount, onDestroy } from 'svelte';
  
  import Call          from './apps/Call.svelte';
  import Contact       from './apps/Contact.svelte';
  import Contacts      from './apps/Contacts.svelte';
  import Dialer        from './apps/Dialer.svelte';
  import IncomingCall  from './apps/IncomingCall.svelte';
  import Messages      from './apps/Messages.svelte';
  import MessageThread from './apps/MessageThread.svelte';
  import OutgoingCall  from './apps/OutgoingCall.svelte';
  
  const apps = {
    call          : Call,
    contact       : Contact,
    contacts      : Contacts,
    dialer        : Dialer,
    incomingcall  : IncomingCall,
    messages      : Messages,
    messagethread : MessageThread,
    outgoingcall  : OutgoingCall,
  };

  let notificationsEl         = null;
  let notificationsElScrollbar = null;

  export let setApp   = null;
  export let app      = null;
  export let appData  = {};
  export let number   = '';
  export let contacts = [];
  export let messages = [];

  export let clock                = Math.floor(new Date / 1000);
  export let battery              = 100;
  export let network              = 100;
  export let displayNotifications = false;

  let clockInterval = null;

  let _clock = '00:00';

  function onTopBarMouseDown(e) {
    displayNotifications = !displayNotifications;
  }


  beforeUpdate(() => {

    const date = new Date(clock * 1000);
    _clock     = `${date.getHours().toString().padStart(2, '0')}:${date.getMinutes().toString().padStart(2, '0')}`;

  });

  onMount(() => {

    clockInterval = setInterval(() => {

      const date = new Date(clock * 1000);
      _clock     = `${date.getHours().toString().padStart(2, '0')}:${date.getMinutes().toString().padStart(2, '0')}`;

    }, 1000);

  });

  onDestroy(() => {
    clearInterval(clockInterval);
  });
  
</script>

<style>
  
  @import url('https://fonts.googleapis.com/css?family=Nunito&display=swap');

  .scrollable::-webkit-scrollbar {
    width: 8px;
  }
  
  .scrollable::-webkit-scrollbar-thumb {
    background: #666;
  }

  .scrollable::-webkit-scrollbar-track {
    background: #ddd;
  }

  * {
    color: #717171;
  }

  .display {
    width : 100%;
    height: 100%;
    background-color: rgb(20, 20, 20);
    font-family: 'Nunito', sans-serif;
    font-size: 0.85em;
    position: relative;
  }

  .display > *:not(.display-background) {
    z-index: 1;
  }

  .display-background {
    position: absolute;
    top: 20px;
    left: 0;
    width: 100%;
    height: calc(100% - 20px);
    background-image: url('./img/wallpaper.png');
    filter: brightness(50%);
    z-index: 0;
  }

  .topbar {
    width: 100%;
    height: 12px;
    display: flex;
    flex-direction: row;
    background-color: rgb(43, 43, 43);
    align-items: center;
    justify-content: space-between;
    padding: 4px;
    user-select: none;
  }

  .battery {
    align-self: flex-start;
    height: 100%;
    width: 32px;
    display: flex;
    flex-direction: row;
    align-items: center;
  }

  .battery-inner {
    border: 1px solid #000;
    width: 100%;
    height: calc(100% - 2px);
  }

  .battery-level {
    background-color: rgb(199, 165, 69);
    width: 100%;
    height: 100%;
  }

  .battery-plus {
    border: 1px solid #000;
    width: 3px;
    height: 6px;
    background-color: rgb(86, 86, 76);;
    margin-left: -1px;
  }

  .clock {
    color: #b1b1b1;
  }

  .network {
    width: 30px;
    height: 100%;
    display: flex;
    flex-direction: row;
    align-self: flex-end;
    align-items: flex-end;
  }

  .network-bar {
    width: 2px;
    margin: 0 1px 0 0;
    background-color: #1ab4e2;
    border: 1px solid #000;
  }

  .network-bar:nth-child(1) { height: 20%; }
  .network-bar:nth-child(2) { height: 40%; }
  .network-bar:nth-child(3) { height: 60%; }
  .network-bar:nth-child(4) { height: 80%; }
  .network-bar:nth-child(5) { height: 100%; }

  .notifications {
    position: relative;
    display: flex;
    flex-direction: column;
    background: rgba(0, 0, 0, 0.75);
    height: 0;
    overflow: hidden;
    transition-property: height;
    transition-duration: 0.5s;
    transition-timing-function: ease-in-out;
    user-select: none;
  }

  .notifications.visible {
    height: calc(100% - 16px);
    overflow-y: auto;
  }

  .notification {
    background: rgba(0, 0, 0, 0.25);
    min-height: 32px;
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
  }

  .notification-icon {
    align-self: flex-start;
    align-self: center;
    padding: 5px;
  }

  .notification-message {
    align-self: center;
  }

  .notification:nth-child(even) {
    background: rgba(20, 20, 20, 0.25);
  }

  .notification:not(:nth-child(1)) {
    border-top: 1px solid rgba(255, 255, 255, 0.05);
  }

  .notification > span {
    text-align: center;
  }

  .main {
    position: relative;
    width : 100%;
    height: calc(100% - 20px - 64px - 16px);
    margin: 8px;
  }

  .dock {
    position: relative;
    margin: 8px;
    border-radius: 5px;
    height: 32px;
    background-color: rgba(255, 255, 255, 0.15);
    display: flex;
    flex-direction: row;
    justify-content: space-evenly;
    align-items: center;
    padding: 8px;
  }

  .dock-icon-desktop:hover li {
    color: #b15dcc;
  }

  .dock-icon-contacts:hover li {
    color: #b18f21;
  }

  .dock-icon-messages:hover li {
    color: #2190b1;
  }

  .dock-icon-phone:hover li {
    color: #0e8618;
  }

</style>

<div class="display">

  <div class="topbar" on:mousedown={e => onTopBarMouseDown(e)}>

    <div class="battery">
      <div class="battery-inner">
        <div class="battery-level" style="width: {battery}%;"></div>
      </div>
      <div class="battery-plus"></div>
    </div>

    <div class="clock">{_clock}</div>
  
    <div class="network">
      {#if network >= 20}<div class="network-bar"></div>{/if}
      {#if network >= 40}<div class="network-bar"></div>{/if}
      {#if network >= 60}<div class="network-bar"></div>{/if}
      {#if network >= 80}<div class="network-bar"></div>{/if}
      {#if network >= 100}<div class="network-bar"></div>{/if}
    </div>

  </div>

  <div class="notifications scrollable {displayNotifications ? 'visible' : ''}" bind:this={notificationsEl}>
    <!-- <div class="notification"><div class="notification-icon"><li class="fas fa-flag"></li></div><div class="notification-message"><span>Foo bar baz</span></div></div> -->
  </div>

  <div class="main">
    {#if app !== null}
      <svelte:component
        this={apps[app]}
        {setApp}
        {number}
        {contacts}
        {messages}
        {...appData}
      />
    {/if}
  </div>

  <div class="dock">
    
    <div class="dock-icon dock-icon-desktop" on:mouseup={e => {app = null}}>
      <li class="fas fa-dove fa-2x"></li>
    </div>

    <div class="dock-icon dock-icon-contacts" on:mouseup={e => setApp('contacts')}>
      <li class="fas fa-address-book fa-2x"></li>
    </div>
    
    <div class="dock-icon dock-icon-messages" on:mouseup={e => setApp('messages')}>
      <li class="fas fa-comment-alt fa-2x"></li>
    </div>

    <div class="dock-icon dock-icon-phone" on:mouseup={e => setApp('dialer')}>
      <li class="fas fa-phone fa-2x"></li>
    </div>

  </div>

  <div class="display-background"></div>

</div>
